> For the complete documentation index, see [llms.txt](https://developer.magtek.com/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://developer.magtek.com/sdks-and-tools/universal-sdk-documentation/.net-windows/ieventsubscriber-delegates.md).

# IEventSubscriber Delegates

This interface invokes a callback function to receive data and/or a detailed response. To register for the event(s), call the subscribeAll() function with the name of a class that implements the IEventSubscriber Delegate interface.

### OnEvent <a href="#id-11.1_onevent" id="id-11.1_onevent"></a>

This is the handler for multiple event types.

{% code overflow="wrap" %}

```
public void OnEvent( 
    EventType eventType, 
    IData data);
```

{% endcode %}

<table data-header-hidden><thead><tr><th width="159" valign="top"></th><th valign="top"></th></tr></thead><tbody><tr><td valign="top">Parameter</td><td valign="top">Description</td></tr><tr><td valign="top">eventType</td><td valign="top">An enumeration for EventType. This indicates the event triggered by the device.</td></tr><tr><td valign="top">data</td><td valign="top">Contains the data for the event. The payload is dependent on the event type.</td></tr></tbody></table>

Return Value: None

**Event implementation**

The OnEvent method must be included and parameterized correctly as shown below to conform to the interface.

In this example, a separate class implements IEventSubscriber.

{% code overflow="wrap" %}

```
class OnEventClass : IEventSubscriber
{
        public void OnEvent(EventType eventType, IData data)
        {
                // Event handler
        }
}
OnEventClass eventCallBack = new OnEventClass(); 
device.subscribeAll(eventCallBack);
```

{% endcode %}

In this example, the main window implements IEventSubscriber. The keyword “this” is used to pass in the name of the current class MainWindow.

{% code overflow="wrap" %}

```
public partial class MainWindow : Window, IEventSubscriber
{
    public void OnEvent(EventType eventType, IData data)
    {
        // Event handler
    }

    private void connectDevice()
    {
        device.subscribeAll(this);
    }
}

```

{% endcode %}

**Event Data Parsing**

Classes can be initialized by passing in the data byte array. Example:

{% code overflow="wrap" %}

```
public void OnEvent(EventType eventType, IData data)
{
        // Barcode data 
        BarCodeData barcodeData =
BarCodeDataBuilder.GetBarCodeData(DeviceType.MMS, data.ByteArray);

        // Input request
        InputRequest ir = new InputRequest(data.ByteArray);

        // NFC data
        NFCData nfcData = NFCDataBuilder.GetNFCData(DeviceType.MMS, data.ByteArray);

        // Enhanced input request 
        EnhancedInputRequest eir = new
EnhancedInputRequest(data.ByteArray);
        List<DirectoryEntry> deList = eir.EnhancedSelectionList;

        }
```

{% endcode %}


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation by asking a question.

Perform an HTTP GET request on the following URL with the `ask` and `goal` query parameters:

```
GET https://developer.magtek.com/sdks-and-tools/universal-sdk-documentation/.net-windows/ieventsubscriber-delegates.md?ask=<question>&goal=<user_goal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is what the user is ultimately trying to achieve, the reason they need the answer. Sharing it helps GitBook give you a better, more relevant answer. A goal is most helpful when it describes the outcome the user wants rather than restating the question. For example, with `ask=how do I create an API token`, a goal like `automate deployments from our CI pipeline` lets GitBook tailor the answer to that use case.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
